<pre><?php
if(!defined('FIRST'))
{
	define('FIRST', true);
	highlight_file(__FILE__);
}
require_once 'basiciterator.php';

abstract class ludi_seekable_iterator extends ludi_basic_iterator implements SeekableIterator
{
}

class ludi_seekable_iterator_index extends ludi_seekable_iterator
{
	public function seek($index)
	{
        $this->rewind();
        $position = 0;
        while($position < $index && $this->valid())
        {
            $this->next();
            $position++;
        }
        if (!$this->valid())
        {
            throw new OutOfBoundsException('Invalid seek position');
        }		
	}
}

class ludi_seekable_iterator_assoc extends ludi_seekable_iterator
{
	public function seek($index)
	{
		$this->rewind();
		while($index != $this->key() && $this->valid())
			$this->next();
		
		if(!$this->valid())
		{
            throw new OutOfBoundsException('Invalid seek position');
        }
	}
}

if($_SERVER['PHP_SELF'] != '/spl/seekableiterator.php')
	return;

$array = array(
	'red' => '#FF0000',
	'green' => '#00FF00',
	'blue' => '#0000FF',
);

echo "\nSeek by Index\n\n";

$seek_index = new ludi_seekable_iterator_index($array);

try
{
	$seek_index->seek(2);
	echo $seek_index->key() . " => " . $seek_index->current() . "\n";
	$seek_index->seek(0);
	echo $seek_index->key() . " => " . $seek_index->current() . "\n";
	$seek_index->seek(3);
	echo $seek_index->key() . " => " . $seek_index->current() . "\n";
}
catch(OutOfBoundsException $e)
{
	print_r($e->getTrace());
}

echo "\nSeek by Key\n\n";

$seek_assoc = new ludi_seekable_iterator_assoc($array);

try
{
	$seek_assoc->seek('red');
	echo $seek_assoc->key() . " => " . $seek_assoc->current() . "\n";
	$seek_assoc->seek('blue');
	echo $seek_assoc->key() . " => " . $seek_assoc->current() . "\n";
	$seek_assoc->seek('purple');
	echo $seek_assoc->key() . " => " . $seek_assoc->current() . "\n";
}
catch(OutOfBoundsException $e)
{
	print_r($e->getTrace());
}
